import CastorcitoForm from './components/Form/castorcito_form.js';

const fields = drupalSettings.field_components;
Object.entries(fields).forEach(([key, field]) => {
  const app = Vue.createApp({
    components: {
      'castorcito-form': CastorcitoForm
    },
    data() {
      const component_id = field.components[0];
      return {
        components: drupalSettings.components,
        formData: {
          componentModel: {},
          fieldsSettings: drupalSettings.components_fields_settings[component_id],
          fieldNameDrupal: key,
          componentId: component_id,
          fieldDeltaDrupal: 0
        }
      };
    },
    mounted() {
      const textareas = document.querySelectorAll('textarea[name^="' + key + '["]');
      textareas.forEach(textarea => {
        const component_id = this.formData.componentId;
        const component = drupalSettings.components[component_id];
        this.formData.componentModel = structuredClone(component);
        this.fieldDeltaDrupal = textarea.getAttribute('target-weight');
        if (textarea.value !== '') {
          const textarea_json = JSON.parse(textarea.value);
          const fields = {};
          this.formData.fieldsSettings.order_fields.forEach(key => {
            if (textarea_json.fields.hasOwnProperty(key)) {
              fields[key] = textarea_json.fields[key];
            }
          });
          textarea_json.fields = fields;
          this.formData.componentModel = textarea_json;
        }
      });
    }
  });

  app.mount('#app_' + key);
});
