import castorcito_fields from './castorcito_fields.js';

export default {
  components: {
    'castorcito-fields': castorcito_fields
  },
  props: ['formData'],
  template: `
    <div tabindex="0" class="castorcito-form" @focusout="saveData">
      <castorcito-fields
        :formData="formData"
        :fieldBaseName="fieldBaseName()"
        :containerDelta="0" />
    </div>
  `,
  methods: {
    fieldBaseName() {
      return `${this.formData.fieldNameDrupal}_${this.formData.fieldDeltaDrupal}_${this.formData.componentId}`;
    },
    saveData() {
      const component = this.formData.componentModel;
      const textareas = document.querySelectorAll('textarea[name^="' + this.formData.fieldNameDrupal + '["]');
      textareas.forEach(textarea => {
        textarea.value = JSON.stringify(component);
      });
    }/*,
    submitForm() {
      const component = this.formData.componentModel;
      const textareas = document.querySelectorAll('textarea[name^="' + this.formData.fieldNameDrupal + '["]');
      textareas.forEach(textarea => {
        textarea.value = JSON.stringify(component);
      });
    }*/
  }
};
