<?php

namespace Drupal\castorcito\Plugin\CastorcitoComponentField;

use Drupal\Core\Form\FormStateInterface;
use Drupal\castorcito\ConfigurableComponentFieldBase;

/**
 * Link configuration.
 *
 * @CastorcitoComponentField(
 *   id = "link",
 *   label = @Translation("Link"),
 *   description = @Translation("Configuration for the link field.")
 * )
 */
class Link extends ConfigurableComponentFieldBase {

  /**
   * {@inheritdoc}
   */
  public function defaultModel() {
    return [
      'value' => '',
      'text' => '',
      'target' => '',
      'external' => TRUE,
      'relative' => '',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration() {
    return [
      'url_autocomplete' => ''
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {
    $castorcito_manager = \Drupal::service('castorcito.manager');
    $this->configuration['url_autocomplete'] = $castorcito_manager->entityAutocompleteUrl('node');
  }

}
